module Tut01 where

{-T1.1-}
offByOne :: Integer -> Integer -> Bool
offByOne x y = x == y + 1 || x + 1 == y

threeAscending :: Integer -> Integer -> Integer -> Bool
threeAscending x y z = x < y && y < z

fourEqual :: Integer -> Integer -> Integer -> Integer -> Bool
fourEqual w x y z = w == x && x == y && y == z

{- T1.2 -}
fac :: Integer -> Integer
fac n
  | n > 0 = n * fac (n - 1)
  | otherwise = 1

sumEleven :: Integer -> Integer
sumEleven n = sumEleven' n 10
  where 
    sumEleven' n 0 = n
    sumEleven' n m = n + m + sumEleven' n (m - 1)

g :: Integer -> Integer
g n = if n < 10 then n*n else n

{- T1.3 -}
argMaxG :: Integer -> Integer
argMaxG 0 = 0
argMaxG n
  | n > 0 = let rec_max = argMaxG (n - 1) in
      if g rec_max > g n then rec_max else n
  | otherwise = 0

argMaxG' :: Integer -> Integer
argMaxG' n
  | n < 0 = 0
  | n >= 10 && n < 81 = 9
  | otherwise = n

prop_argMaxGEquiv :: Integer -> Bool
prop_argMaxGEquiv n = argMaxG n == argMaxG' n
